PRO CLEANWID_Event, Event

  ; Recover the state:
  widget_control,Event.top,get_uvalue=state

  ; See which button was pressed:
  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'destripe_toggle': BEGIN
      IF Event.Select THEN Sel = 'On' ELSE Sel = 'Off'
      If Sel EQ 'On' then destripe='On'
  END
  
  'despike_toggle': BEGIN
      IF Event.Select THEN Sel = 'On' ELSE Sel = 'Off'
      If Sel EQ 'On' then despike='On'
  END  
  
  'spatial_despike_toggle': BEGIN
      IF Event.Select THEN Sel = 'On' ELSE Sel = 'Off'
      If Sel EQ 'On' then despike='On'
  END  
  
  'ok_button': BEGIN
  
  ;GET VALUES
  widget_control,state.destripegrp,get_value=destripe
  widget_control,state.gkernelsize,get_value=kernelsize
  widget_control,state.gkernelsdx,get_value=kernelsdx
  widget_control,state.gkernelsdl,get_value=kernelsdl
  widget_control,state.despikegrp,get_value=despike
  widget_control,state.gthreshold,get_value=threshold

      ; Send info to pointer location that lives outside of widget
      (*state.ptr).choices=[destripe,kernelsize,kernelsdx,kernelsdl, $
                            despike, threshold]
      ;Kill the GUI
      widget_control,event.top,/destroy

      Print, 'Beginning Cirrus Cleaning'
  END
  
  'cancel_button': BEGIN
      ; If CANCEL, kill GUI:
      widget_control,Event.top,/destroy
      Print, 'Process cancelled'
      END
      
  'help_button': BEGIN
      Print, 'Event for help_button'
      crism_clean_help
      END
   
   ELSE:
  ENDCASE

END





PRO clean_widget, GROUP=Group, choices

  GROUP=0

  CLEANWID = WIDGET_BASE(GROUP_LEADER=Group, COLUMN=1, UVALUE='CLEANWID')

  BASE1 = WIDGET_BASE(CLEANWID, COLUMN=1, FRAME=1, TITLE='Destripe', UVALUE='BASE1')

    Btns_destripe = [ 'Destripe' ]
    DESTRIPEGRP = CW_BGROUP( BASE1, Btns_destripe, ROW=1, NONEXCLUSIVE=1, UVALUE='destripe_toggle')

    default_kernelsize = [ '30' ]
    gkernelsize = CW_FIELD( BASE1,VALUE=default_kernelsize, ROW=1, FLOAT=1, ALL_EVENTS=1, $
                TITLE='Gaussian kernel size', XSIZE=5, UVALUE='kernelsize_value_input')

    default_kernelsdx = [ '17' ]
    gkernelsdx = CW_FIELD( BASE1,VALUE=default_kernelsdx, ROW=1, FLOAT=1, ALL_EVENTS=1, $
               TITLE='Gaussian kernel sigma spatial', XSIZE=4, UVALUE='kernelsdx_input')

    default_kernelsdl = [ '2' ]
    gkernelsdl = CW_FIELD( BASE1,VALUE=default_kernelsdl, ROW=1, FLOAT=1, ALL_EVENTS=1, $
               TITLE='Gaussian kernel sigma spectral', XSIZE=4, UVALUE='kernelsdl_input')

  Base2 = WIDGET_BASE(CLEANWID, COLUMN=1, FRAME=1, MAP=1, TITLE='Despike', UVALUE='Base2')

    Btns_despike = [ 'Despike' ]
    DESPIKEGRP = CW_BGROUP( Base2, Btns_despike, ROW=1, NONEXCLUSIVE=1, UVALUE='despike_toggle')

    default_threshold = [ '2' ]
    gthreshold = CW_FIELD( Base2,VALUE=default_threshold, ROW=1, FLOAT=1, ALL_EVENTS=1, TITLE='threshold_input',$
                 XSIZE=8, UVALUE='gthreshold')
  
  BASE_options = WIDGET_BASE(CLEANWID, ROW=1, MAP=1, TITLE='done_cancel_help_base', $
                 UVALUE='BASE_options')

    OK_BUTT = WIDGET_BUTTON( BASE_options, UVALUE='ok_button', VALUE='OK')

    CANCEL_BUTT = WIDGET_BUTTON( BASE_options, UVALUE='cancel_button', VALUE='CANCEL')

    HELP_BUTT = WIDGET_BUTTON( BASE_options, UVALUE='help_button', VALUE='HELP')


  ; Create a pointer location where choices can be stored "off-site"
  ptr = Ptr_New({choices:['','','','','','','']})

  ; Keep useful information in a state structure:
  state =  {destripegrp:destripegrp,   $
            gkernelsize:gkernelsize,   $
            gkernelsdx:gkernelsdx,     $
            gkernelsdl:gkernelsdl,     $
            despikegrp:despikegrp,     $
            gthreshold:gthreshold,     $
            ptr:ptr}
; Save the state structure in the base uvalue and realize application:
  WIDGET_CONTROL, CLEANWID, set_uvalue=state, /REALIZE

;Handoff control of application to xmanager:
  XMANAGER, 'CLEANWID', CLEANWID

; Get info from "off-site" location and clear pointer
choices=(*ptr).choices
ptr_free,ptr
END
