;02/06/2009 (fps)
;   Initial development - Widget interface for mro_crism_continuum_cube()
;   	Query user for continuum tie point information, output options, and output filenames
;02/06/2009 (fps) - Changes since sending code to RVM @ ~4:45 ET
;   Improved documentation
;02/07/2009 (fps)
;   Modified default output filenames (suggested by RVM)   
;11/15/2011 (fps)
;   Added not-yet-enabled reference band functionality
;   Revised widget parameter defaults
;   	3-point spectral median
;   	Tie-point wavelengths
;10/15/2015 (mfm)
;   Reset default_indx to [2,nb-3] to give median filter room so doesn't crash 
;	on defaults.
;

;Widget handler functions/procedures...
;

pro mro_crism_continuum_cube_envi_gui_event, event

    ;print, event
    ;help, event, /struct

    widget_control, event.top, get_uvalue = base_info_ptr
    title_string = (*base_info_ptr).title_string

    print, title_string + ' Event...'    

END


function mro_crism_continuum_cube_envi_gui_cancel_button_event, event
   
    ;print, event
    ;help, event, /struct

    widget_control, event.top, get_uvalue = base_info_ptr
    (*(*base_info_ptr).return_info_ptr).cancel = 1
    title_string = (*base_info_ptr).title_string
    
    widget_control, event.top, /destroy

    print, title_string + ' Cancel Event...'

return, 0
END


pro mro_crism_continuum_cube_envi_gui_cleanup, main_base

    widget_control, main_base, get_uvalue = base_info_ptr
    title_string = (*base_info_ptr).title_string
        
    ptr_free, base_info_ptr

    print, title_string + ' Cleanup...'

END


function mro_crism_continuum_cube_envi_gui_ok_button_event, event
    ;print, event
    ;help, event, /struct

    widget_control, event.top, get_uvalue = base_info_ptr
    title_string = (*base_info_ptr).title_string
    
    widget_control, (*base_info_ptr).ref_base, get_uvalue = ref_base_info
    widget_control, ref_base_info.ref_select, get_value = ref_select

    ;Deactivate cancel...
    (*(*base_info_ptr).return_info_ptr).cancel = 0
    
    (*(*base_info_ptr).return_info_ptr).ref_select = ref_select

    param_indx = make_array(n_elements(ref_base_info.param_combo), value = -1)
    param_text = make_array(n_elements(ref_base_info.param_combo), value = '')

    for i = 0, n_elements(ref_base_info.param_combo) -1 do begin
    	widget_control, ref_base_info.param_combo[i], get_uvalue = combo_indx
    	combo_text = widget_info(ref_base_info.param_combo[i], /combobox_gettext)
    	param_indx[i] = combo_indx
	param_text[i] = combo_text
    endfor
    (*(*base_info_ptr).return_info_ptr).param_indx = param_indx
    (*(*base_info_ptr).return_info_ptr).param_text = param_text

    widget_control, (*base_info_ptr).median_base, get_uvalue = median_base_info
    widget_control, median_base_info.median_select, get_value = median_select
    median_text = widget_info(median_base_info.median_window, /combobox_gettext)
    (*(*base_info_ptr).return_info_ptr).median_select = median_select
    (*(*base_info_ptr).return_info_ptr).median_text = median_text

    ;Param band select
    widget_control, (*base_info_ptr).tie_band_base, get_uvalue = param_band_base_struct
    widget_control, param_band_base_struct.tie_band_select_base, get_uvalue = tie_band_select
    widget_control, tie_band_select, get_value = tie_band_select_vec

    (*(*base_info_ptr).return_info_ptr).tie_band_select_vec = tie_band_select_vec
 
    
    ;Param band info...
    widget_control, (*base_info_ptr).tie_band_base, get_uvalue = param_band_base_struct

    for i = 0, n_elements(param_band_base_struct.param_band_base_vector) -1 do begin
    	widget_control, param_band_base_struct.param_band_base_vector[i], get_uvalue = param_band_button
    	widget_control, param_band_button, get_uvalue = param_band_text
    	widget_control, param_band_text, get_uvalue = param_band_struct
    	help, param_band_struct, /str
	        
    	param_band_return_struct = {fid:param_band_struct.fid, pos:param_band_struct.pos, dims:param_band_struct.dims, file_name:param_band_struct.fname, band_name:param_band_struct.bnames[(param_band_struct.pos > 0)]}
    	help, param_band_return_struct, /str

    	(*(*base_info_ptr).return_info_ptr).param_band_struct[i] = param_band_return_struct
		
    endfor
    
    ;Requested results...    
    widget_control, (*base_info_ptr).result_base, get_uvalue = result_base_info
    
    widget_control, result_base_info.result_select, get_value = result_select
    (*(*base_info_ptr).return_info_ptr).result_select = result_select
    
    outfm_array = result_base_info.outfm_array
    for i = 0, n_elements(result_select) -1 do begin
    	widget_control, outfm_array[i], get_value = outfm_struct
    	(*(*base_info_ptr).return_info_ptr).outfm_result_array[i] = outfm_struct
    endfor   
    
    

    ;stop
    
    widget_control, event.top, /destroy

    print, title_string + ' OK...'

return, 0
END


function continuum_cube_result_select_event, event
    ;print, event
    ;help, event, /struct

    widget_control, event.top, get_uvalue = base_info_ptr
    widget_control, (*base_info_ptr).result_base, get_uvalue = result_base_info
    
    widget_control, result_base_info.result_select, get_value = result_select
    ;print, result_select
    
    outfm_array = result_base_info.outfm_array
    for i = 0, n_elements(result_select) -1 do begin
    	widget_control, outfm_array[i], sensitive = result_select[i]
    endfor   
    
    

return, 0
END

function continuum_cube_ref_select_event, event
    ;print, event
    ;help, event, /struct
    
    widget_control, event.handler, get_uvalue = ref_base_info
    ;help, ref_base_info, /str

    ref_select = event.result
    ;print, ref_select
    
    for i = 0, n_elements(ref_base_info.param_combo) -1 do begin
    	widget_control, ref_base_info.param_combo[i], get_uvalue = combo_indx
    	widget_control, ref_base_info.param_combo[i], set_value = ref_base_info.xvec_struct.(ref_select)
	widget_control, ref_base_info.param_combo[i], set_combobox_select = combo_indx
    endfor
 
return, 0
END


function continuum_cube_tie_band_select_event, event
    ;print, event
    ;help, event, /str
    
    widget_control, event.id, get_uvalue = param_band_base_struct
    print, param_band_base_struct
    help, param_band_base_struct, /str

    widget_control, event.top, get_uvalue = base_info_ptr
    ref_base = (*base_info_ptr).ref_base
    widget_control, ref_base, get_uvalue = ref_base_info
    
   ; stop

    for w = 0, n_elements(param_band_base_struct.param_band_base_vector) -1 do begin
    	widget_control, param_band_base_struct.param_band_base_vector[w], sensitive = event.result[w]
	widget_control, ref_base_info.param_combo[w], sensitive = (event.result[w] EQ 0)
    endfor

return, 0
END

function continuum_cube_band_select_event, event
    ;print, event
    ;help, event, /str
    
    widget_control, event.id, get_uvalue = param_text
    
    ;Select input wavelength band from available bands list
    envi_select, fid=in_fid, pos=in_pos, dims=in_dims, file_type=in_file_type, /band_only, title='!!'
    envi_file_query, in_fid, fname = in_filename, ns=ns, nl=nl, nb=nb, bnames=in_bnames
    
    if (in_fid NE -1) then begin
    	band_struct = {fid:in_fid, pos:in_pos, dims:in_dims, file_type:in_file_type, fname:in_filename, ns:ns, nl:nl, nb:nb, bnames:in_bnames}
	widget_control, param_text, set_value = in_bnames[in_pos] + ': ' + '(' + strtrim(in_filename, 2) + ')'
	widget_control, param_text, set_uvalue = band_struct
    endif

;stop

return, 0
END


function continuum_cube_median_filter_event, event
    ;print, event
    ;help, event, /struct
    
    ;print, event.result

    widget_control, event.handler, get_uvalue = median_base_info
    widget_control, median_base_info.median_window, sensitive = event.result

return, 0
END


function continuum_cube_combo_event, event
    ;print, event
    ;help, event, /struct

    widget_control, event.id, set_uvalue = event.index

return, 0
END

function continuum_cube_non_event, event
    ;print, event
    ;help, event, /struct

return, 0
END


;
;Main function specification
;

function mro_crism_continuum_cube_envi_gui, in_file, nb, wavelength_vec = wavelength_vec, default_indx = default_indx

title_string = 'MRO CRISM CONTINUUM CUBE'

in_file_path = file_dirname(in_file)
in_file_basename = file_basename(in_file)
in_file_name = file_basename(in_file, '.IMG')
   
print, in_file_path
print, in_file_basename
print, in_file_name

cont_default_file = in_file_path + path_sep() + in_file_name + '_continuum' + '.IMG'
ratio_default_file = in_file_path + path_sep() + in_file_name + '_ratio' + '.IMG'
param_default_file = in_file_path + path_sep() + in_file_name + '_parameter' + '.IMG'

band_vec = string(lindgen(nb))

if ((not(keyword_set(wavelength_vec))) OR (n_elements(wavelength_vec) NE nb)) then begin
    wavelength_vec = band_vec
endif else begin
    wavelength_vec = string(wavelength_vec)
endelse

med_vec = string(lindgen(nb * 0.025) * 2 + 1)

if (not(keyword_set(default_indx))) then begin
    default_indx = [(2 < nb-1), ((nb-3) > 0)]   ; Not 0,nb-1 leave room for median 3
    default_indx = default_indx[sort(default_indx)]  ; for bizarre case nb=2or3
endif

main_base = widget_base(title = title_string, /column, xoffset = 100, yoffset = 100)

cont_base = widget_base(main_base, frame=1, /column)
    cont_label = widget_label(cont_base, value = 'Continuum Options:')
    ref_base = widget_base(cont_base, frame=1, event_func = 'continuum_cube_ref_select_event')
    	ref_list = ['Wavelength', 'Band Index']
    	ref_select = widget_menu(ref_base, list = ref_list, uvalue = 'ref_select', /exclusive, default_ptr = 0)

    xvec_struct = {wavelength_vec:wavelength_vec, band_vec:band_vec}

    param_base = widget_base(cont_base, frame=1, /row)
    	tie_base = widget_base(param_base, frame=1, /column)
    	    param_x1_label = widget_label(tie_base, value = 'Tie Point X1: ')
    	    param_x1 = widget_combobox(tie_base, value = wavelength_vec, event_func = 'continuum_cube_combo_event')
    	    param_x2_label = widget_label(tie_base, value = 'Tie Point X2: ')
      	    param_x2 = widget_combobox(tie_base, value = wavelength_vec, event_func = 'continuum_cube_combo_event')

    param_combo = [param_x1, param_x2]

    widget_control, param_x1, set_combobox_select = default_indx[0]
    widget_control, param_x2, set_combobox_select = default_indx[1]
    
    widget_control, param_x1, set_uvalue = default_indx[0]
    widget_control, param_x2, set_uvalue = default_indx[1]


    ref_base_info = {xvec_struct:xvec_struct, param_combo:param_combo, ref_select:ref_select}
    widget_control, ref_base, set_uvalue = ref_base_info	
	
	median_base = widget_base(param_base, frame=1, /column, event_func = 'continuum_cube_median_filter_event')
	    median_list = ['Median Filter']
    	    ;median_select = widget_menu(median_base, list = median_list, uvalue = 'median_select', default_array = [0])
	    median_select = widget_menu(median_base, list = median_list, uvalue = 'median_select', default_array = [1])
    	    median_label = widget_label(median_base, value = 'Window Size')
    	    median_window = widget_combobox(median_base, value = med_vec, event_func = 'continuum_cube_combo_event')
	    
	    widget_control, median_window, sensitive = 1
    	    widget_control, median_window, set_combobox_select = 1

    	median_base_info = {median_select:median_select, median_window:median_window}
	widget_control, median_base, set_uvalue = median_base_info

    tie_band_base = widget_base(cont_base, frame=1, /column)
    	param_band_default_struct = {fid:long(-1), pos:long(-1), dims:make_array(5, value = long(-1)), fname:'', bnames:''}
	
    	tie_band_select_base = widget_base(tie_band_base, frame=1, /row, event_func = 'continuum_cube_tie_band_select_event')
	    tie_band_list = ['Tie Band X1', 'Tie Band X2']
	    tie_band_select = widget_menu(tie_band_select_base, list = tie_band_list)
	    
	    widget_control, tie_band_select_base, set_uvalue = tie_band_select
	    
    	param_x1_band_base = widget_base(tie_band_base, frame = 1, /row)
    	    param_x1_button = widget_button(param_x1_band_base, value = 'Select X1', event_func = 'continuum_cube_band_select_event')
	    param_x1_text = widget_text(param_x1_band_base, value = '', xsize = 25)
	;test = envi_select(main_base, frame=1, default = cont_default_file, uvalue = 'cont_outfm', prompt = 'Continuum Cube: ')
    	widget_control, param_x1_button, set_uvalue = param_x1_text
	widget_control, param_x1_band_base, sensitive = 0
	widget_control, param_x1_band_base, set_uvalue = param_x1_button
	
	widget_control, param_x1_text, set_uvalue = param_band_default_struct
	
    	param_x2_band_base = widget_base(tie_band_base, frame = 1, /row)	    	
    	    param_x2_button = widget_button(param_x2_band_base, value = 'Select X2', event_func = 'continuum_cube_band_select_event')
	    param_x2_text = widget_text(param_x2_band_base, value = '', xsize = 25)	
    	widget_control, param_x2_button, set_uvalue = param_x2_text
     	widget_control, param_x2_band_base, sensitive = 0
	widget_control, param_x2_band_base, set_uvalue = param_x2_button

	widget_control, param_x2_text, set_uvalue = param_band_default_struct

    	widget_control, tie_band_select, set_uvalue = {param_band_base_vector:[param_x1_band_base, param_x2_band_base]}
	widget_control, tie_band_base, set_uvalue = {tie_band_select_base:tie_band_select_base, param_band_base_vector:[param_x1_band_base, param_x2_band_base]}

    	widget_control, tie_band_base, sensitive = 0
	 
    result_base = widget_base(cont_base, frame=1, /column, event_func = 'continuum_cube_result_select_event')
    	result_label = widget_label(result_base, value = 'Output Selection:')
    	result_list = ['Continuum', 'Ratio', 'Parameter']
    	result_select = widget_menu(result_base, list = result_list, uvalue = 'result_select', default_array = [1,1,0])
        

    cont_outfm = widget_outfm(main_base, frame=1, default = cont_default_file, uvalue = 'cont_outfm', prompt = 'Continuum Cube: ')
    ratio_outfm = widget_outfm(main_base, frame=1, default = ratio_default_file, uvalue = 'ratio_outfm', prompt = 'Ratio Cube: ')
    param_outfm = widget_outfm(main_base, frame=1, default = param_default_file, uvalue = 'param_outfm', prompt = 'Parameter Cube: ')
        
    widget_control, cont_outfm, sensitive = 1
    widget_control, ratio_outfm, sensitive = 1
    widget_control, param_outfm, sensitive = 0

    result_base_info = {result_select:result_select, outfm_array:[cont_outfm, ratio_outfm, param_outfm]}
    widget_control, result_base, set_uvalue = result_base_info

    command_base = widget_base(main_base, frame=1, /row)
    	button_x_size = 50
    	ok_button = widget_button(command_base, value = 'OK', xsize = button_x_size, event_func = 'mro_crism_continuum_cube_envi_gui_ok_button_event')
	cancel_button = widget_button(command_base, value = 'Cancel', xsize = button_x_size, event_func = 'mro_crism_continuum_cube_envi_gui_cancel_button_event')


return_info_ptr = ptr_new({cancel:0, $
    	    	    	   ref_select:-1, param_indx:[-1,-1], param_text:['',''], median_select:-1, median_text:'', $
			   tie_band_select_vec:replicate(long(-1), 2), $
			   param_band_struct:replicate(param_band_default_struct, 2), $
			   result_select:[-1,-1,-1], outfm_result_array:replicate({name:'', in_memory:long(-1), compression:-1}, 3)})
   
base_info = {return_info_ptr:return_info_ptr, $
	     title_string:title_string, main_base:main_base, cont_base:cont_base, tie_band_base:tie_band_base, result_base:result_base, ref_base:ref_base, median_base:median_base}

base_info_ptr = ptr_new(base_info)
;base_info_ptr = ptr_new(0)

widget_control, main_base, set_uvalue = base_info_ptr


widget_control, main_base, /realize

;This is a blocking widget so the user info can be retreived from the return_info ptr and returned after the widget is destroyed
XMANAGER, 'mro_crism_continuum_cube_envi_gui', main_base, cleanup = 'mro_crism_continuum_cube_envi_gui_cleanup'

;Use non-blocking for development
;XMANAGER, 'mro_crism_continuum_cube_envi_gui', main_base, cleanup = 'mro_crism_continuum_cube_envi_gui_cleanup', /no_block

help, return_info_ptr
;print, ptr_valid(return_info_ptr)

return_info = *return_info_ptr
ptr_free, return_info_ptr

;help, return_info

return, return_info

END
